--[[
Addon: 			Bang! Libram Swap
Description: 	A Mod to maximise the power of this versitile item slot for all paladin specs.
Author:			Bangerz of Jubei'Thos (Oceanic)
Website:		http://www.curse.com/downloads/details/12351/
Credit to:		HasBoL and HasMendingBuff code from Ladenedge's Holy Librams.
Thanks to:		Katana/Calthas, Stormbringer, for their help with translations.
				Posters on Curse for their ideas and Paladins in Fade for their feedback and ideas (except Yogo :P)

Release >Beta< Build: 2.43.B1  (24321)

2.4.3:

Protection and Retribution modes unchanged

Holy Healing librams can no longer be used in combat if your spell has a cast time.
They will instead now be swapped in when you use an instant.

]]--

BangLibramSwap = LibStub("AceAddon-3.0"):NewAddon("BangLibramSwap", "AceEvent-3.0", "AceConsole-3.0", "AceComm-3.0")
local BangLibramSwap = BangLibramSwap
--local L = LibStub("AceLocale-3.0"):GetLocale("BangLibramSwap", true)
local L = AceLibrary("AceLocale-2.2"):new("BangLibramSwap")
local optionsFrame

function BangLibramSwap:OnInitialize()

if (select(2, UnitClass("player")) ~= "PALADIN") then
    		DEFAULT_CHAT_FRAME:AddMessage("BLS: Disabled!", 0.0, 1.35, 0.3)
    		--DisableAddOn("Bang!_Libram_Swap")
	return
end

--DBObject:RegisterDefaults(defaults, {
local defaults = {
    profile = {
   Enabled=true,
   LowCPU=false,
   Version="Bang Libram Swap 2.43.A3",
   NumVersion="24313",
   VersionSpam=false,
   SpellClip=250,
   Mp5Mode=true,
   AutoMode=true,
   AutoSpec=true,
   BGG=true,
   LoAT=false,
   LotL=true,
   LoSR=true,
   LoSRFoL=false,
   LoM=false,
   NoLoM=false,
   LoL=false,
   BBoN=false,
   ret=false,
   prot=false,
   holy=true,
   UseLoM=true,
   DJ=true,
   JB=true,
   HS=true,
   PVEOverride=false,
   ProtDP=false,
   HolyES=true,
   HolyCD=true,
   HolyDP=true,
   Debug=false,
   AV=false,
   CR=false,
   SpamProof = false,
   Ret2Cycle=false,
   Ret3Cycle=false,
   Ret4Cycle=false,
   LoZ=false,
   Glad1=false,
   Glad2=false,
   Glad3=true,
   Glad4=false,
   PHS1=false,
   libram = "Libram of Mending",
   PHS2=false,
   PHS3=false,
   PHS4=false,
   RetJudge1=false,
   RetJudge2=false,
   RetJudge3=false,
   RetJudge4=false,
   AutoLatencyDone=false,
   RP=false,
   RefreshWindow=4.0,
   JudgementCooldown=8.0,
   STFU6=false,}
}

  options = {
    type="group",
    name = "Bang! Libram Swap",
    childGroups = "tab",
    plugins = {},
    args = {
    --	frame = {
	  -- Front Page
     			 GUI = {
          		  type = "execute",
          		  name = "`GUI`",
          		  desc = "Diplay the GUI",
           		 func = function() BangLibramSwap:ChatCommand() end,
              --width = "half",
           		 order=-1,
           		 guiHidden = true,

        },

			  enable = {
           		 type = "toggle",
           		 name = "Enabled",
           		 desc = "Libram Swaps Enabled",
    		     get=function() return self.db.profile.Enabled end,
    	         set=function(v) BangLibramSwap:SetEnabled() end,
              --width = "half",
                order=1,
              },



    		Latency = {
            type = "range",
            name = "Latency (ms)",
            desc = "Adjust this to your >Lowest< latency. If you experience spell interupts make it lower, if your librams aren't swapping make it higher. ",
            min = 10,
            max = 1000,
            step = 10,
			order = 4,
            get = function()
				return self.db.profile.SpellClip
				end,
			set = function(info, value)
				self.db.profile.SpellClip = value
				BangLibramSwap:SetSpellClip(value)
				end
			},


                frame10 = {

	type="group",
    name = "General",
    childGroups = "tab",
    order = 1,
    plugins = {},
    args = {
			PVPPVE = {
            type = "header",
            name = "PVE/PVP:",
            desc = " ",
            order = 2,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },


                pvp = {
            		type = "toggle",
           			 name = "PVP Mode",
           		 	desc = "Use PVP librams",
    				get=function() return (not(self.db.profile.Mp5Mode)) end,
    				set=function() BangLibramSwap:SetPVPMode() end,
                	order=4,
                },

                pve = {
            		type = "toggle",
            		name = "PVE Mode",
            		desc = "Use PVE librams",
    				get=function() return self.db.profile.Mp5Mode end,
    				set=function() BangLibramSwap:SetPVEMode() end,
               		 order=5,
              },
			  
              AutoMode = {
            type = "toggle",
            name = "Auto Detect PVP/PVE",
            desc = "Automatically Detect PVP/PVE",
            order=3,
			get=function() return self.db.profile.AutoMode end,
    		set=function(v) BangLibramSwap:SetAutoMode() end,
      --width = "half",

            },
              
            debug = {
            type = "toggle",
            name = "Debug",
            desc = "Toggle Debug Messages",
            order = 13,
            --width = "half",
    		get=function() return self.db.profile.Debug end,
    		set=function(v) BangLibramSwap:SetDebug() end,

        },   

             PVPPVE2 = {
            type = "header",
            name = "Spec:",
            desc = " ",
            order = 6,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },

     HolyMode = {
            type = "toggle",
            name = "Holy Mode",
            desc = "Toggle Healing and Spell Damage Librams",
            order = 8,
    		get=function() return self.db.profile.holy end,
      --width = "half",
    		set=function() BangLibramSwap:SetHolyMode() end,

        },

     RetMode = {
            type = "toggle",
            name = "Retribution Mode",
            desc = "Toggle Retribution Damage and Resilience librams",
            order = 9,
    		get=function() return self.db.profile.ret end,
      --width = "half",
    		set=function() BangLibramSwap:SetRetMode() end,

        },


     ProtMode = {
            type = "toggle",
            name = "Protection Mode",
            desc = "Toggle Tanking and Spell Damage Librams",
            order = 10,
    		get=function() return self.db.profile.prot end,
    --width = "half",
    		set=function() BangLibramSwap:SetProtMode() end,

        },
             PVPPVE3 = {
            type = "header",
            name = "Extra:",
            desc = " ",
            order = 11,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },


        	SlowCPU = {
            type = "toggle",
            name = "Slow CPU",
            desc = "This disables events required for protection and retribution modes, but reduces CPU load.",
            order = 12,
			get=function() return self.db.profile.LowCPU end,
      --width = "half",
    		set=function(v) BangLibramSwap:SetLowCPU() end,

        },

	AutoSpec = {
            type = "toggle",
            name = "Auto Change Spec",
            desc = "Automatically choose spec based on abilities used",
            order = 7,
			get=function() return self.db.profile.AutoSpec end,
      --width = "half",
    		set=function(v) BangLibramSwap:SetAutoSpec() end,

        } } },
		  
		  
		  

    frame2 = {    
	   
	type="group",
    name = "Holy Librams",
    childGroups = "tab",
    order = 2,
    plugins = {},
    args = {
	   
	        HolyLightHeader = {
            type = "header",
            name = "Holy Light Libram #1:",
            desc = " ",
            order = 0,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,

        	},
	   
	    	LoM2 = {
            type = "toggle",
            name = "Use the Libram of Mending +HL #2",
            desc = "Toggle using the Libram of Mending on HL #1",
            width = "full",
			order = 1,
    		get=function() return self.db.profile.UseLoM end,
    		set=function() BangLibramSwap:UseLoM() end,
            },
	   
	        LoM = {
            type = "toggle",
            name = "*Only* Use the Libram of Mending ",
            desc = "Toggle using the Libram of Mending *Only* (This disables HL#2 below)",
            width = "full",
			order = 2,
    		get=function() return self.db.profile.LoM end,
    		set=function() BangLibramSwap:LoM() end,

            },

            NoLoM = {
            type = "toggle",
            name = "Do not use the Libram of Mending",
            desc = "Disable using the Libram of Mending (If you dont have it)",
            width = "full",
			order = 3,
    		get=function() return self.db.profile.NoLoM end,
    		set=function() BangLibramSwap:NoLoM() end,
    		},

    		LoMRecast = {
            type = "range",
            name = "Recast LoM Buff@",
            desc = "Recast LoM Buff @ X Time Temaning",
            min = 1,
            max = 25,
            step = 1,
			order = 4,
            get = function()
				return self.db.profile.RefreshWindow
				end,
			set = function(info, value)
				self.db.profile.RefreshWindow = value
				BangLibramSwap:SetLoMRecast(value)
				end
			},
            
            
            HolyLight2Header = {
            type = "header",
            name = "Holy Light Libram #2:",
            desc = " ",
            order = 5,
        	get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
    		},
        
	        LoAT = {
            type = "toggle",
            name = "Libram of Absolute Truth",
            desc = "Use the Libram of Absolute Truth on 2nd HL (You may use LoSR but it is not recommended)",
            width = "full",
			order = 6,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,

        	},
	   
	        LotL = {
            type = "toggle",
            name = "Libram of the Lightbringer",
           desc = "Use the Libram of the Lightbringer on 2nd HL (You should also select LoSR)",
            width = "full",
			order = 7,
    		get=function() return self.db.profile.LotL end,
    		set=function() BangLibramSwap:LotL() end,

           },


            LoSR = {
            type = "toggle",
            name = "Libram of Souls Redeemed (if BoL)",
            desc = "Toggle the Libram of Souls Redeemed on 2nd HL (You should also select LotL",
            width = "full",
			order = 8,
    		get=function() return self.db.profile.LoSR end,
    		set=function() BangLibramSwap:LoSR() end,

            },
	   
	        FlashofLightHeader = {
            type = "header",
            name = "PVE Flash of Light Librams:",
            desc = " ",
            order = 10,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	   
	        LoL = {
            type = "toggle",
            name = "Libram of Light",
            desc = "Toggle the Libram of Light",
            width = "full",
			order = 11,
    		get=function() return self.db.profile.LoL end,
    		set=function() BangLibramSwap:LoL() end,

            },

            BBoN = {
            type = "toggle",
            name = "Blessed Book of Nagrand",
            desc = "Toggle the Blessed Book of Nagrand",
            order = 12,
            width = "full",
    		get=function() return self.db.profile.BBoN end,
    		set=function() BangLibramSwap:BBoN() end,

             },

       

	        LoSRFoL = {
             type = "toggle",
            name = "Libram of Souls Redeemed (if BoL)",
            desc = "Toggle the Libram of Souls Redeemed on FoL if BoL is up",
            width = "full",
			order = 13,
    		get=function() return self.db.profile.LoSRFoL end,
    		set=function() BangLibramSwap:LoSRFoL() end,

            },
	    
	        PVPFlashofLightHeader = {
            type = "header",
            name = "PVP Flash of Light Librams:",
            desc = " ",
            order = 20,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	   
	        Glad1 = {
            type = "toggle",
            name = "Gladiator's Libram of Justice",
            desc = "Toggle the Gladiator's Libram of Justice",
            width = "full",
			order = 21,
    		get=function() return self.db.profile.Glad1 end,
    		set=function() BangLibramSwap:Glad1() end,

            },

            Glad2 = {
            type = "toggle",
            name = "Merciless Gladiator's Libram of Justice",
            desc = "Toggle the Merciless Gladiator's Libram of Justice",
            order = 22,
            width = "full",
    		get=function() return self.db.profile.Glad2 end,
    		set=function() BangLibramSwap:Glad2() end,

             },

       

	        Glad3 = {
             type = "toggle",
            name = "Vengeful Gladiator's Libram of Justice",
            desc = "Toggle the Vengeful Gladiator's Libram of Justice",
            width = "full",
			order = 23,
    		get=function() return self.db.profile.Glad3 end,
    		set=function() BangLibramSwap:Glad3() end,

            },
        
            Glad4 = {
             type = "toggle",
            name = "Brutal Gladiator's Libram of Justice",
            desc = "Toggle the Brutal Gladiator's Libram of Justice",
            width = "full",
			order = 24,
    		get=function() return self.db.profile.Glad4 end,
    		set=function() BangLibramSwap:Glad4() end,

            },
        
            ExtraHolyHeader = {
            type = "header",
            name = "Holy Spell Damage Librams:",
            desc = " ",
            order = 25,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	   
	        HolyDP = {
            type = "toggle",
            name = "Libram of Divine Purpose",
            desc = "Use the Libram of Divine Purpose while Judging in Holy mode",
            width = "full",
			order = 26,
    		get=function() return self.db.profile.HolyDP end,
    		set=function() BangLibramSwap:HolyDP() end,

            },

            HolyES = {
            type = "toggle",
            name = "Libram of Wracking",
            desc = "Use the Libram of Wracking on Exocism and Holy Wrath",
            order = 27,
            width = "full",
    		get=function() return self.db.profile.HolyES end,
    		set=function() BangLibramSwap:HolyES() end,

             },

       

	        HolyCD = {
             type = "toggle",
            name = "Libram of the Eternal Rest",
            desc = "Use the Libram of the Eternal Rest on Consecration",
            width = "full",
			order = 28,
    		get=function() return self.db.profile.HolyCD end,
    		set=function() BangLibramSwap:HolyCD() end,

            },
        
	        } -- Args Holy Librams
	        
	        }, -- Frame Holy librams
	        
	    frame3 = {    
	   
	type="group",
    name = "Ret Librams",
    order = 3,
    childGroups = "tab",
    plugins = {},
    args = {
	   
	        RetCycleHeader = {
            type = "header",
            name = "Advanced Ret Cycles:",
            desc = " ",
            order = 25,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	        Ret2Cycle = {
            type = "toggle",
            name = "2 Step: Judgement",
            width = "full",
            desc = "Toggle cycling between the librams of Avengement and Divine Judgement (You need both). You may also choose Libram of Righteous Power but it is not recommended.",
            order = 26,
    		get=function() return self.db.profile.Ret2Cycle end,
    		set=function() BangLibramSwap:Ret2Cycle () end,

        	},
        	
        	 Ret3Cycle = {
            type = "toggle",
            name = "3 Step: 2 Step +Exorcism",
            width = "full",
            desc = "Will cycle in Libram of Wracking. Selecting this disables LoRP.",
            order = 27,
    		get=function() return self.db.profile.Ret3Cycle end,
    		set=function() BangLibramSwap:Ret3Cycle () end,

        	},
			
			RetCrusaderStrikeHeader = {
            type = "header",
            name = "Crusader Strike Librams:",
            desc = " ",
            order = 28,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	        RetRP = {
            type = "toggle",
            name = "Libram of Righteous Power",
            width = "full",
            desc = "Toggle the Libram of Righteous Power (This option may cause swing timer issues - enable only if you know what you are doing).",
            order = 29,
    		get=function() return self.db.profile.RP end,
    		set=function() BangLibramSwap:RetRP() end,

        	},
        	
        	 RetCrusaderSealHeader = {
            type = "header",
            name = "Seal of the Crusader Librams:",
            desc = " ",
            order = 40,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	        RetLoZ = {
            type = "toggle",
            name = "Libram of Zeal",
            width = "full",
            desc = "Toggle the Libram of Zeal on SotC",
            order = 41,
    		get=function() return self.db.profile.LoZ end,
    		set=function() BangLibramSwap:LoZ() end,

        	},
	   
	        RetPVEJudgementHeader = {
            type = "header",
            name = "PVE Judgement Librams:",
            desc = " ",
            order = 32,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	        RetDJ = {
            type = "toggle",
            name = "Libram of Divine Judgement",
            width = "full",
            desc = "Toggle the Libram of Divine Judgement",
            order = 33,
    		get=function() return self.db.profile.DJ end,
    		set=function() BangLibramSwap:RetDJ() end,

        	},
        	
        	  RetAV = {
            type = "toggle",
            name = "Libram of Avengement",
            width = "full",
            desc = "Toggle the Libram of Avengement",
            order = 34,
    		get=function() return self.db.profile.AV end,
    		set=function() BangLibramSwap:RetAV() end,

        	},
	   
	        RetPVPJudgementHeader = {
            type = "header",
            name = "PVP Judgement Librams:",
            desc = " ",
            order = 35,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	        RetJudge1 = {
            type = "toggle",
            name = "Gladiator's Libram of Fortitude",
            width = "full",
            desc = "Toggle Gladiator's Libram of Fortitude",
            order = 36,
    		get=function() return self.db.profile.RetJudge1 end,
    		set=function() BangLibramSwap:RetJudge1() end,

        	},
        	
        	  RetJudge2 = {
            type = "toggle",
            name = "Merciless Gladiator's Libram of Fortitude",
            width = "full",
            desc = "Toggle Merciless Gladiator's Libram of Fortitude",
            order = 37,
    		get=function() return self.db.profile.RetJudge2 end,
    		set=function() BangLibramSwap:RetJudge2() end,

        	},
        	
        	RetJudge3 = {
            type = "toggle",
            name = "Vengeful Gladiator's Libram of Fortitude",
            width = "full",
            desc = "Toggle Vengeful Gladiator's Libram of Fortitude",
            order = 38,
    		get=function() return self.db.profile.RetJudge3 end,
    		set=function() BangLibramSwap:RetJudge3() end,

        	},
        	
        	  RetJudge4 = {
            type = "toggle",
            name = "Brutal Gladiator's Libram of Fortitude",
            width = "full",
            desc = "Brutal Gladiator's Libram of Fortitude",
            order = 39,
    		get=function() return self.db.profile.RetJudge4 end,
    		set=function() BangLibramSwap:RetJudge4() end,

        	},
	   
	        } -- Args Ret Librams
	        
	        }, -- Frame Ret librams
			
			frame4 = {    
	   
	type="group",
    name = "Prot Librams",
    order = 4,
    childGroups = "tab",
    plugins = {},
    args = {
	   
	   
	       ProtHolyShieldHeader = {
            type = "header",
            name = "Holy Shield Librams:",
            desc = " ",
            order = 40,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	        ProtHS = {
            type = "toggle",
            name = "Libram of Repentance",
            width = "full",
            desc = "Toggle the Libram of Repentance",
            order = 41,
    		get=function() return self.db.profile.HS end,
    		set=function() BangLibramSwap:ProtHS() end,

        	},
	   
	        ProtJudgementHeader = {
            type = "header",
            name = "PVE Judgement Librams:",
            desc = " ",
            order = 42,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	        ProtDP = {
            type = "toggle",
            name = "Libram of Divine Purpose",
            width = "full",
            desc = "Toggle the Libram of Divine Purpose",
            order = 43,
    		get=function() return self.db.profile.ProtDP end,
    		set=function() BangLibramSwap:ProtDP() end,

        	},
        	
        	  ProtTotL = {
            type = "toggle",
            name = "Tome of the Lightbringer",
            width = "full",
            desc = "Toggle the Tome of the Lightbringer",
            order = 44,
    		get=function() return self.db.profile.JB end,
    		set=function() BangLibramSwap:ProtJB() end,

        	},
	   
	        RetPVPJudgementHeader = {
            type = "header",
            name = "PVP Prot Librams:",
            desc = " ",
            order = 45,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	         PHS1 = {
            type = "toggle",
            name = "Gladiator's Libram of Vengeance",
            width = "full",
            desc = "Toggle Gladiator's Libram of Vengeance",
            order = 46,
    		get=function() return self.db.profile.PHS1 end,
    		set=function() BangLibramSwap:PHS1() end,

        	},
        	
        	  PHS2 = {
            type = "toggle",
            name = "Merciless Gladiator's Libram of Vengeance",
            width = "full",
            desc = "Toggle Merciless Gladiator's Libram of Vengeance",
            order = 47,
    		get=function() return self.db.profile.PHS2 end,
    		set=function() BangLibramSwap:PHS2() end,

        	},
        	
        	PHS3 = {
            type = "toggle",
            name = "Vengeful Gladiator's Libram of Vengeance",
            width = "full",
            desc = "Toggle Vengeful Gladiator's Libram of Vengeance",
            order = 48,
    		get=function() return self.db.profile.PHS3 end,
    		set=function() BangLibramSwap:PHS3() end,

        	},
        	
        	  PHS4 = {
            type = "toggle",
            name = "Brutal Gladiator's Libram of Vengeance",
            width = "full",
            desc = "Brutal Gladiator's Libram of Vengeance",
            order = 49,
    		get=function() return self.db.profile.PHS4 end,
    		set=function() BangLibramSwap:PHS4() end,

        	},  
	        } -- args prot
	        }, -- frame prot
	        
        	frame5 = {    
	   
	type="group",
    name = "About",
    order = 6,
    childGroups = "tab",
    plugins = {},
    args = {
	   
	   
	       AboutHeader = {
            type = "header",
            name = "About Bang! Holy Librams",
            desc = " ",
            order = 50,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },  	   
	   
	         AboutDescription = {
            type = "description",
            name = "Bang! Holy Librams: By Bangerz of Jubei'thos Oceanic!",
            desc = " ",
            order = 51,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         }, 
	   
	              AboutDescription2 = {
            type = "description",
            name = "The Ultimate Smart Paladin Libram Swapper: Check the librams you want to use in the three tabs here. Using Auto Detect PVP/PVE is highly recomended.",
            desc = " ",
            order = 52,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         }, 
			  
			  
			      AboutDescription3 = {
            type = "description",
            name = " ",
            desc = " ",
            order = 53,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         }, 
	   
	          AboutDescription4 = {
            type = "description",
            name = "Primary Mod Website: http://www.curse.com/downloads/details/12351",
            desc = " ",
            order = 54,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         }, 
	         
	          AboutDescription5 = {
            type = "description",
            name = "Accepting localizations for your clients language, simply modify localization.lua and post it in a ticket at the above site.",
            desc = " ",
            order = 55,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         }, 
	   
	            AboutDescription6 = {
            type = "description",
            name = "Proud member of <Fade>: www.FadeGuild.com.au",
            desc = " ",
            order = 56,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         }, 
	   
	        } -- Args About
	        
	        }, -- Frame 5
	   

	         

	   
	   }, } -- Profile, Options


    self:RegisterChatCommand("bls", "ChatCommand")
    self:RegisterChatCommand("BangLibramSwap", "ChatCommand")
 	self.db = LibStub("AceDB-3.0"):New("BangLibramSwapDB", defaults, "Default")
    LibStub("AceConfig-3.0"):RegisterOptionsTable("BangLibramSwap", options)
    optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("BangLibramSwap", "BangLibramSwap")

    if (self.db.profile.Debug) then DEFAULT_CHAT_FRAME:AddMessage("BLS: Debug On", 1.0, 0.85, 0.43)  end
		if (not (self.db.profile.STFU6)) then
 			DEFAULT_CHAT_FRAME:AddMessage("Bang! Libram Swap v"..self.db.profile.Version.." First Time Loaded: /bls (for options)", 1.0, 0.85, 0.43)
        self.db.profile.STFU6 = true
    end

end

function BangLibramSwap:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToFrame("BangLibramSwap")
       -- InterfaceOptionsFrame_OpenToFrame(BangLibramSwapoptionsFrame)
    else
        BangLibramSwap:slashHandler(input)
    end
end

function BangLibramSwap:GetLibram()
 BangLibramSwap:Debug("GetLibram: ", self.db.profile.libram)
return self.db.profile.libram
end

function BangLibramSwap:slashHandler(input)
local self = BangLibramSwap

   BGLF  = L["Brutal Gladiator's Libram of Fortitude"] 	-- +39 resil
   VGLF  = L["Vengeful Gladiator's Libram of Fortitude"] 	-- +36 resil
   MGLF  = L["Merciless Gladiator's Libram of Fortitude"]   -- + 32 resil
   GLF  = L["Gladiator's Libram of Fortitude"] 		    -- 24 resil

   BGLV  = L["Brutal Gladiator's Libram of Vengeance"] 	-- +39 resil
   VGLV  = L["Vengeful Gladiator's Libram of Vengeance"] 	-- +36 resil
   MGLV  = L["Merciless Gladiator's Libram of Vengeance"]   -- + 32 resil
   GLV  = L["Gladiator's Libram of Vengeance"] 		    -- 24 resil
   LoSR = L["Libram of Souls Redeemed"]   -- BoL 60/120
   BBoN = L["Blessed Book of Nagrand"]    -- FoL +78
   LoAT = L["Libram of Absolute Truth"]   -- HL -37 mana
   LoM  = L["Libram of Mending"]          -- HL 22mp5
   LotL = L["Libram of the Lightbringer"] -- HL +89
   LoL  = L["Libram of Light"]            -- FoL +82
   BGL  = L["Brutal Gladiator's Libram of Justice"] 	-- +36 resil
   VGL  = L["Vengeful Gladiator's Libram of Justice"] 	-- +36 resil
   MGL  = L["Merciless Gladiator's Libram of Justice"]   -- + 32 resil
   GGL  = L["Gladiator's Libram of Justice"] 		    -- 24 resil

   LoRP = L["Libram of Righteous Power"]  -- +36 Crusader strike
   LoDJ = L["Libram of Divine Judgement"] -- JoC proc 200AP
   LoAV = L["Libram of Avengement"] -- JoC proc crit rating

   LoDP = L["Libram of Divine Purpose"]   -- +97 Righteousness
   LoCD = L["Libram of the Eternal Rest"] -- +47 concecrate
   LoES = L["Libram of Wracking"]  		 -- +120 Ex/HW

   LoHS = L["Libram of Repentance"]     	-- +5% Holy shield block
   LoJB = L["Tome of the Lightbringer"] 	 -- +189 block value
   LoZ  = L["Libram of Zeal"]  -- SotC Bonus
-- re add am I casting


  if input == "gui" then
     InterfaceOptionsFrame_OpenToFrame("BangLibramSwap")
  elseif input == "pve" then
  DEFAULT_CHAT_FRAME:AddMessage("BLS: PVE Mode", 1.0, 0.85, 0.43)
    self.db.profile.Mp5Mode = true;
    elseif input == "wrath" and (BangLibramSwap.db.profile.holy) and (BangLibramSwap.db.profile.HolyES) and (BangLibramSwap.db.profile.Enabled)then
   	  		BangLibramSwap:Debug("Wrath Hard Fired - Equipping", LoES)
			   EquipItemByName(LoES)
  elseif input == "pvp" then
  DEFAULT_CHAT_FRAME:AddMessage("BLS: PVP Mode", 1.0, 0.85, 0.43)
    self.db.profile.Mp5Mode = false;
  elseif input == "aoe" then
    DEFAULT_CHAT_FRAME:AddMessage("BLS: AoE", 1.0, 0.85, 0.43)
	self.db.profile.HolyCD = true;
	self.db.profile.HS = false;
	
elseif (input == "flash of light")  then
     


	      
	      
elseif (input == "holy light")  then


	


   	if (NoSwapTime)  and (self.db.profile.Enabled) and (self.db.profile.holy) then
		LastSwap = NoSwapTime - GetTime()
	
		if (LastSwap <= 0) and (BangLibramSwap:CanCastHeal()) and (self.db.profile.Enabled) then
    		BangLibramSwap:GetLibram()
			--EquipItemByName(self.db.profile.libram)
			if self.db.profile.libram == L["Libram of Mending"] then
			LoMCast = GetTime()
			end
		elseif (LastSwap > 0)  and (LastSwap < 0.25)  then
		    NoSwapTime = NoSwapTime + 0.35
		end
	end

  elseif input == "crush" then
    DEFAULT_CHAT_FRAME:AddMessage("BLS: Crush Proofing", 1.0, 0.85, 0.43)
	self.db.profile.HolyCD = false;
	self.db.profile.HS = true;
  elseif input == "debug" then
    if (self.db.profile.Debug) then
    self.db.profile.Debug = false
    DEFAULT_CHAT_FRAME:AddMessage("BLS: Debug: OFF", 1.0, 0.85, 0.43)
    else
    self.db.profile.Debug = true
    DEFAULT_CHAT_FRAME:AddMessage("BLS: Debug: ON", 1.0, 0.85, 0.43)
    end
  elseif input == "help" then
    DEFAULT_CHAT_FRAME:AddMessage(self.db.profile.Version, 1.0, 0.85, 0.43)
    DEFAULT_CHAT_FRAME:AddMessage("/bls gui", 1.0, 0.85, 0.43)
    DEFAULT_CHAT_FRAME:AddMessage("/bls pvp, /bls pve", 1.0, 0.85, 0.43)
    DEFAULT_CHAT_FRAME:AddMessage("/bls crush, /bls aoe", 1.0, 0.85, 0.43)
    DEFAULT_CHAT_FRAME:AddMessage("/bls holy light, /bls flash of light, /bls wrath", 1.0, 0.85, 0.43)
  end
end


function BangLibramSwap:PLAYER_TARGET_CHANGED()
name, realm = UnitName("target")
	if name == "Bangerz" and not (stfulol) then
       DoEmote("praise", "target")
	   stfulol = true
	end
end

function BangLibramSwap:SetSpellClip(value)
self.db.profile.SpellClip= value
end

function BangLibramSwap:SetLoMRecast(value)
self.db.profile.RefreshWindow = value
end

function BangLibramSwap:LoAT()
		self.db.profile.LotL = false;
        self.db.profile.LoM = false;
		self.db.profile.LoAT = true;
end

function BangLibramSwap:LotL()
		self.db.profile.LotL = true
        self.db.profile.LoM = false
		self.db.profile.LoAT = false;
end

function BangLibramSwap:BBoN()
		self.db.profile.LoL = false
        self.db.profile.BBoN = true;
end

function BangLibramSwap:LoL()
		self.db.profile.LoL = true
        self.db.profile.BBoN = false;
end

function BangLibramSwap:LoSR()
        if (self.db.profile.LoSR) then
        self.db.profile.LoSR = false
        else
		self.db.profile.LoSR = true
		end
end

function BangLibramSwap:LoSRFoL()
        if (self.db.profile.LoSRFoL) then
        self.db.profile.LoSRFoL = false
        else
		self.db.profile.LoSRFoL = true
		end
end

function BangLibramSwap:LoM()
		if (not(self.db.profile.LoM)) then
		self.db.profile.LotL = false
        self.db.profile.LoSR = false
        self.db.profile.LoM = true
        self.db.profile.NoLoM = false
        self.db.profile.UseLoM = false
		self.db.profile.LoAT = false;
		else
		self.db.profile.LoM = false
		DEFAULT_CHAT_FRAME:AddMessage("BLS: HL1+2 unlocked, please select a HL2 Libram.", 1.0, 0.85, 0.43)
		end
 end

function BangLibramSwap:NoLoM()
        if (not(self.db.profile.NoLoM)) then
        self.db.profile.LoM = false
        self.db.profile.UseLoM = false
        self.db.profile.NoLoM = true;
		else
		self.db.profile.NoLoM = false;
		end
end
function BangLibramSwap:UseLoM()
        if (not(self.db.profile.UseLoM)) then
        self.db.profile.UseLoM = true
        self.db.profile.NoLoM = false
		else
		self.db.profile.UseLoM = false
		end
end
	
function BangLibramSwap:Glad1()
        if (not(self.db.profile.Glad1)) then
		self.db.profile.Glad1 = true
        self.db.profile.Glad2 = false
        self.db.profile.Glad3 = false
		self.db.profile.Glad4 = false
		end
end
function BangLibramSwap:Glad2()
        if (not(self.db.profile.Glad2)) then
		self.db.profile.Glad2 = true
        self.db.profile.Glad1 = false
        self.db.profile.Glad3 = false
		self.db.profile.Glad4 = false
		end
end
function BangLibramSwap:Glad3()
        if (not(self.db.profile.Glad3)) then
		self.db.profile.Glad3 = true
        self.db.profile.Glad2 = false
        self.db.profile.Glad1 = false
		self.db.profile.Glad4 = false
		end
end
function BangLibramSwap:Glad4()
        if (not(self.db.profile.Glad4)) then
        self.db.profile.Glad3 = false
        self.db.profile.Glad2 = false
        self.db.profile.Glad1 = false
		self.db.profile.Glad4 = true
		end
end

function BangLibramSwap:RetJudge1()
        if (not(self.db.profile.RetJudge1)) then
		self.db.profile.RetJudge1 = true
        self.db.profile.RetJudge2 = false
        self.db.profile.RetJudge3 = false
		self.db.profile.RetJudge4 = false
		else
		self.db.profile.RetJudge1 = false
		end
end
function BangLibramSwap:BGG()
        if (not(self.db.profile.BGG)) then
		self.db.profile.BGG = true
		else
		self.db.profile.BGG = false
		end
end

function BangLibramSwap:RetJudge2()
        if (not(self.db.profile.RetJudge2)) then
		self.db.profile.RetJudge2 = true
        self.db.profile.RetJudge1 = false
        self.db.profile.RetJudge3 = false
		self.db.profile.RetJudge4 = false
		else
		self.db.profile.RetJudge2 = false
		end
end
function BangLibramSwap:RetJudge3()
        if (not(self.db.profile.RetJudge3)) then
		self.db.profile.RetJudge3 = true
        self.db.profile.RetJudge2 = false
        self.db.profile.RetJudge1 = false
		self.db.profile.RetJudge4 = false
		else
		self.db.profile.RetJudge3 = false
		end
end
function BangLibramSwap:RetJudge4()
        if (not(self.db.profile.RetJudge4)) then
        self.db.profile.RetJudge3 = false
        self.db.profile.RetJudge2 = false
        self.db.profile.RetJudge1 = false
		self.db.profile.RetJudge4 = true
		else
		self.db.profile.RetJudge4 = false
		end
end

function BangLibramSwap:PHS1()
        if (not(self.db.profile.PHS1)) then
		self.db.profile.PHS1 = true
        self.db.profile.PHS2 = false
        self.db.profile.PHS3 = false
		self.db.profile.PHS4 = false
		else
		self.db.profile.PHS1 = false
		end
end
function BangLibramSwap:PHS2()
        if (not(self.db.profile.PHS2)) then
		self.db.profile.PHS2 = true
        self.db.profile.PHS1 = false
        self.db.profile.PHS3 = false
		self.db.profile.PHS4 = false
		else
		self.db.profile.PHS2 = false
		end
end
function BangLibramSwap:PHS3()
        if (not(self.db.profile.PHS3)) then
		self.db.profile.PHS3 = true
        self.db.profile.PHS2 = false
        self.db.profile.PHS1 = false
		self.db.profile.PHS4 = false
		else
		self.db.profile.PHS3 = false
		end
end
function BangLibramSwap:PHS4()
        if (not(self.db.profile.PHS4)) then
        self.db.profile.PHS3 = false
        self.db.profile.PHS2 = false
        self.db.profile.PHS1 = false
		self.db.profile.PHS4 = true
		else
		self.db.profile.PHS4 = false
		end
end

function BangLibramSwap:RetRP()
        if (not(self.db.profile.RP)) then
        		if not (self.db.profile.Ret3Cycle) then
				self.db.profile.RP = true;
				else
				DEFAULT_CHAT_FRAME:AddMessage("BLS: Unable to enable LoRP - 3 Step Cycle active.", 1.0, 0.85, 0.43)
				end
		else
			    self.db.profile.RP = false;
		end
end
function BangLibramSwap:RetDJ()
      if (not(self.db.profile.DJ)) then
      self.db.profile.DJ = true
      self.db.profile.AV = false;
      else
      	if not (self.db.profile.Ret2Cycle) then
	  	self.db.profile.DJ = false;
	  	end

     end
end
function BangLibramSwap:RetAV()
      if (not(self.db.profile.AV)) then
      self.db.profile.AV = true
      self.db.profile.DJ = false;
      else
	    self.db.profile.AV = false;
     end
end

function BangLibramSwap:Ret2Cycle()
      if (not(self.db.profile.Ret2Cycle)) then
      self.db.profile.AV = true;
      self.db.profile.DJ = true;
      self.db.profile.Ret2Cycle = true;
      self.db.profile.RP = false;
      DEFAULT_CHAT_FRAME:AddMessage("BLS: Ret 2 Cycle Enabled: Libram of Divine Judgement and Libram of Avengement have been selected. You may also choose Righteous Power but it is not recommended.", 1.0, 0.85, 0.43)
      else
      self.db.profile.AV = false;
      self.db.profile.DJ = false;
      self.db.profile.Ret2Cycle = false;
      self.db.profile.Ret3Cycle = false;
      DEFAULT_CHAT_FRAME:AddMessage("BLS: Ret 2 Cycle Disabled: Libram of Divine Judgement and Libram of Avengement have been deselected, please choose 1.", 1.0, 0.85, 0.43)
     end
end
function BangLibramSwap:Ret3Cycle()
      if (not(self.db.profile.Ret3Cycle)) then
      self.db.profile.AV = true;
      self.db.profile.DJ = true;
      self.db.profile.Ret3Cycle = true;
      self.db.profile.Ret2Cycle = true;
      self.db.profile.HolyES = true;
      self.db.profile.RP = false;
       DEFAULT_CHAT_FRAME:AddMessage("BLS: Ret 3 Cycle Enabled: Libram of Wracking selected (Holy tab), LoRP Disabled (Ret tab). You can now deselect LoAV if you do not have it.", 1.0, 0.85, 0.43)
      else
      self.db.profile.Ret3Cycle = false;
     end
end

function BangLibramSwap:LoZ()
      if (not(self.db.profile.LoZ)) then
      self.db.profile.LoZ = true
      else
      self.db.profile.LoZ = false;
     end
end


function BangLibramSwap:ProtHS()
        if (not(self.db.profile.HS)) then
		self.db.profile.HS = true;
		else
		self.db.profile.HS = false;
		end
end
function BangLibramSwap:ProtJB()
        if (not(self.db.profile.JB)) then
        self.db.profile.JB = true
        self.db.profile.ProtDP = false;
        else
         self.db.profile.JB = false;
		end
end
function BangLibramSwap:ProtDP()
        if (not(self.db.profile.ProtDP)) then
        self.db.profile.JB = false
        self.db.profile.ProtDP = true;
        else
        self.db.profile.ProtDP = false;
		end
end

function BangLibramSwap:HolyDP()
        if (not(self.db.profile.HolyDP)) then
           self.db.profile.HolyDP = true;

		else
        	self.db.profile.HolyDP = false;
		end

end
function BangLibramSwap:HolyES()
        if (not(self.db.profile.HolyES)) then
           self.db.profile.HolyES = true;

		else
        	self.db.profile.HolyES = false;
        end
end
function BangLibramSwap:HolyCD()
		if (not(self.db.profile.HolyCD)) then
            self.db.profile.HolyCD = true;
		else
        	self.db.profile.HolyCD = false;
        end
end


function BangLibramSwap:SetPVEMode()
	if self.db.profile.Mp5Mode then
		self.db.profile.Mp5Mode = false
	else
		self.db.profile.Mp5Mode = true
	end
end
function BangLibramSwap:SetPVPMode()
	if self.db.profile.Mp5Mode then
		self.db.profile.Mp5Mode = false
	else
		self.db.profile.Mp5Mode = true
	end
end
function BangLibramSwap:SetHolyMode(v)
        self.db.profile.holy = true
		self.db.profile.prot = false
		self.db.profile.ret = false
end
function BangLibramSwap:SetRetMode(v)
        self.db.profile.holy = false
		self.db.profile.prot = false
		self.db.profile.ret = true
end
function BangLibramSwap:SetProtMode(v)
        self.db.profile.holy = false
		self.db.profile.prot = true
		self.db.profile.ret = false
end
function BangLibramSwap:SetLowCPU(v)
if not (self.db.profile.LowCPU) then
        self.db.profile.LowCPU = true
        self.db.profile.holy = true
		self.db.profile.prot = false
		self.db.profile.ret = false
		DEFAULT_CHAT_FRAME:AddMessage("Slow CPU - Retribution and Protection modes disabled.", 1.0, 0.25, 0.23)
elseif (self.db.profile.LowCPU) then
self.db.profile.LowCPU = false

end
end



function BangLibramSwap:SetAutoMode()
	if (self.db.profile.AutoMode) then
		self.db.profile.AutoMode = false
	else
		self.db.profile.AutoMode = true
	end
end
function BangLibramSwap:SetAutoSpec()
	if (self.db.profile.AutoSpec) then
		self.db.profile.AutoSpec = false
	else
		self.db.profile.AutoSpec = true
	end
end
function BangLibramSwap:SetEnabled()
	if (self.db.profile.Enabled) then
		self.db.profile.Enabled = false
	else
		self.db.profile.Enabled = true
	end
end
function BangLibramSwap:SetDebug()
	if (self.db.profile.Debug) then
		self.db.profile.Debug = false
	else
		self.db.profile.Debug = true
	end
end

function BangLibramSwap:OnEnable()
if (select(2, UnitClass("player")) ~= "PALADIN") then
	return
end
self:RegisterEvent("UNIT_SPELLCAST_SENT")
self:RegisterEvent("UNIT_SPELLCAST_START")
self:RegisterEvent("UNIT_SPELLCAST_STOP")
self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")  
self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
self:RegisterEvent("UNIT_SPELLCAST_FAILED")
--self:RegisterEvent("VARIABLES_LOADED")
self:RegisterEvent("SPELL_UPDATE_COOLDOWN")
if not (self.db.profile.LowCPU) then
self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end
--self:RegisterEvent("ZONE_CHANGED")
self:RegisterEvent("PLAYER_TARGET_CHANGED")
self:RegisterEvent("CHAT_MSG_ADDON");            
self:RegisterEvent("PARTY_MEMBERS_CHANGED");    
SFX = GetCVar("Sound_EnableSFX")
DontSpam = false
SpamBreak = false
SpamProof = false;
end



function BangLibramSwap:PARTY_MEMBERS_CHANGED() 
SendAddonMessage("Bang!LS", self.db.profile.NumVersion, "PARTY")
SendAddonMessage("Bang!LS", self.db.profile.NumVersion, "RAID")
SendAddonMessage("Bang!LS", self.db.profile.NumVersion, "BATTLEGROUND")
SendAddonMessage("Bang!LS", self.db.profile.NumVersion, "GUILD")
end

function BangLibramSwap:CHAT_MSG_ADDON(arg1, arg2, arg3, arg4)
 local sender = arg4
 local message = arg3
 if arg2 == "Bang!LS" then
	if (self.db.profile.VersionSpam) then
		return
	end
	if (message > self.db.profile.NumVersion) then
    	DEFAULT_CHAT_FRAME:AddMessage("BLS: Ver. "..self.db.profile.NumVersion.." is outdated. Someone in my "..sender.." has Ver. "..message..".", 1.0, 0.35, 0.23)
    	self.db.profile.VersionSpam = true
	end

 end
end

	
function BangLibramSwap:SPELL_UPDATE_COOLDOWN(event)
if (select(2, UnitClass("player")) ~= "PALADIN") then
	return
end
BangLibramSwap:IsJudgementUp()
end


function BangLibramSwap:COMBAT_LOG_EVENT_UNFILTERED(event)
if (select(2, UnitClass("player")) ~= "PALADIN") then
	return
end
self = BangLibramSwap
if (self.db.profile.LowCPU) then
	return
end

   local LoRP = L["Libram of Righteous Power"]  -- +36 Crusader strike
   local LoDJ = L["Libram of Divine Judgement"] -- JoC proc 200AP
   local LoAV = L["Libram of Avengement"] -- JoC proc crit rating
   local LoDP = L["Libram of Divine Purpose"]   -- +97 Righteousness
   local LoCD = L["Libram of the Eternal Rest"] -- +47 concecrate
   local LoES = L["Libram of Wracking"]  		 -- +120 Ex/HW
   local LoHS = L["Libram of Repentance"]     	-- +5% Holy shield block
   local LoJB = L["Tome of the Lightbringer"] 	 -- +189 block value

   local BGLF  = L["Brutal Gladiator's Libram of Fortitude"] 	-- +39 resil
   local VGLF  = L["Vengeful Gladiator's Libram of Fortitude"] 	-- +36 resil
   local MGLF  = L["Merciless Gladiator's Libram of Fortitude"]   -- + 32 resil
   local GLF  = L["Gladiator's Libram of Fortitude"] 		    -- 24 resil

   local BGLV  = L["Brutal Gladiator's Libram of Vengeance"] 	-- +39 resil
   local VGLV  = L["Vengeful Gladiator's Libram of Vengeance"] 	-- +36 resil
   local MGLV  = L["Merciless Gladiator's Libram of Vengeance"]   -- + 32 resil
   local GLV  = L["Gladiator's Libram of Vengeance"] 		    -- 24 resil

   BangLibramSwap:LoDJBuff()
  		    -- Judgement logic. Prot
 			if (BangLibramSwap:IsProtJudgementUp()) and (self.db.profile.prot) and (self.db.profile.Enabled) and (not (BangLibramSwap:HSGCD())) then

					  if (self.db.profile.JB) then
			  			if (self.db.profile.prot) then
					   	EquipItemByName(LoJB)
					   	BangLibramSwap:Debug("Equip prot", LoJB)
					   	end
					end
 			end

 			if (BangLibramSwap:IsProtJudgementUp()) and (self.db.profile.prot) and (self.db.profile.Enabled) and (not (BangLibramSwap:HSGCD()) ) then
			 if (self.db.profile.ProtDP) then

					   EquipItemByName(LoDP)
					   BangLibramSwap:Debug("Equip prot", LoDP)
  			end
			end
   			-- Holy Shield Logic
            if (BangLibramSwap:HSUp()) then
			if (self.db.profile.Enabled)  then
			  		if (self.db.profile.HS) then
			  		if (self.db.profile.prot) then

			  			
			  			if (self.db.profile.Mp5Mode) then
					   			EquipItemByName(LoHS)
					   			 BangLibramSwap:Debug("Prot ", LoHS)
					   	elseif (not(self.db.profile.Mp5Mode)) then
					   	         BangLibramSwap:Debug("Prot ", GLV)
					   		if  (self.db.profile.PHS1) then
			  	    			EquipItemByName(GLV)
			  	    		end
			  	    		if  (self.db.profile.PHS2) then
  			  	    			EquipItemByName(MGLV)
			  	    		end
			  	    		if  (self.db.profile.PHS3) then
			  	    			EquipItemByName(VGLV)
			  	    		end
			  	    		if  (self.db.profile.PHS4) then
			  	    			EquipItemByName(BGLV)
			  	    		end
					   	
					   	
					   	end
					end
					end
 		    end

			end
 			-- Crusader Strike logic
   			if (self.db.profile.ret) and (self.db.profile.RP)  and (self.db.profile.Enabled) then

   	 		  if (not(BangLibramSwap:Execute())) then
	   
   	   		 	if (not (BangLibramSwap:IsJudgementUp()) ) then
        		local itemname, itemlink, rarity, _, _, _, _, _, _, _ = GetInventoryItemLink("player",GetInventorySlotInfo("RangedSlot"))    --return the item name and rarity
	   	 			if (not (itemname == "Libram of Righteous Power")) then
   	        			if (not(BangLibramSwap:JudgementCD2())) and (BangLibramSwap:CSCD2()) then
			 				if (not (BangLibramSwap:Overlap2()) )then
			  	    		EquipItemByName(LoRP)
			  				end
            			else
        				self:Debug("Potential GCD, Judge->CS swap aborted", 1.0, 0.85, 0.43)
		    			end   -- end GCD check and swaps
		   			else
		   			self:Debug("3) CS libram already in - cancel", 1.0, 0.85, 0.43)
		  			end  -- end itemname libram check
        		end   -- end judgement used check

	  		  end -- end Execute check
	 
   		     end  --- end retmode check

end  -- End Event

-- Prot Mode [ Standard cooldowns + latency/delay for event ]
function BangLibramSwap:IsProtJudgementUp()

  local start, duration, enabled = GetSpellCooldown(L["Judgement"])

  
if (duration) then
local cd = (start + duration) - GetTime()
  if (cd) then
	if (cd < 2.3) and (cd > 0) then
	     return true
	else
	     return false
	end
  end
end
end



function BangLibramSwap:HSGCD()
	 
    local start, duration, enabled = GetSpellCooldown(L["Holy Shield"])
    if (start) then
    	local cd = (start + duration) - GetTime()
    elseif not (start) then
    BangLibramSwap:Debug("Unable to check Holy Shield GCD")
	end
    if (cd) then
		if (cd < 1.7) and (cd > 0) then
	   	  	return true
		else
	        return false
	    end
    end
end

function BangLibramSwap:Execute()
local usable, nomana = IsUsableSpell(L["Hammer of Wrath"])

	if usable == 1 then return true
	else return false
	end

end

function BangLibramSwap:HSUp()

    local start, duration, enabled = GetSpellCooldown(L["Judgement"])

 if (duration) then
   local cd = (start + duration) - GetTime()
   		if (cd) then
			if (cd >= 2.3) and (cd < 10) then
	     		return true
		else
	    		 return false
			end
   		end
  else
  BangLibramSwap:Debug("Unable to check Judgement CD")
   return false
  end
end

function BangLibramSwap:IsJudgementUp()

    local start, duration, enabled = GetSpellCooldown(L["Judgement"])
    if (duration) then
	local cd = (start + duration) - GetTime()


   if (cd) then
	if (cd > 1.5) and (cd < 11) then
	     return false
	else
	     return true
	end
   end
   end
end

-- Ret Mode MK.II [Agressive GCDs - Judgement is off GCD of CS. Poor rotations may case GCD issues]
function BangLibramSwap:JudgementCD2()  -- Ret Mode

    local start, duration, enabled = GetSpellCooldown(L["Judgement"])  --, BOOKTYPE_SPELL
    if (start) then
	local cd = (start + duration) - GetTime()

   if (cd) then
	if ((cd < .5) and (cd > 0)) or ((cd > 7.5) and (cd < 10.1)) then
	return true
	else
	return false
	end
   end
    	end
end

function BangLibramSwap:CSCD2()  -- Ret Mode

	local start, duration, enabled = GetSpellCooldown(L["Crusader Strike"])  --, BOOKTYPE_SPELL
    if (start) then
	local cd = (start + duration) - GetTime()

   if (cd) then
	if (cd > 1.5) and (cd < 6.1) then
	return true
	else
	return false
	end
   end
   	end
end

function BangLibramSwap:LoDJBuff()

local LoDJ_buff_name = "Crusader's Command"

   for id = 1,100 do
      local name, _, _, _, _, time_left = UnitBuff("player", id)
      if (not name or not time_left) then
         return false
      elseif (name == LoDJ_buff_name) then
         --self:Debug("Ret buff is active, timeleft: ", time_left)
         LoDJProc = GetTime() 
         return true
      end
   end

end

-- Ret Mode [Agressive overlap - prevent inferior CS libram from swapping in if cooldowns are close]
function BangLibramSwap:Overlap2()

	local start, duration, enabled = GetSpellCooldown(L["Crusader Strike"])  --, BOOKTYPE_SPELL
	if (duration) then
	local cd = (start + duration) - GetTime()
	
	local starts, durations, enableds = GetSpellCooldown(L["Judgement"])  --, BOOKTYPE_SPELL
	local cds = (starts + durations) - GetTime()
	
   if (cd < 6) and (cd > 0) and (cds >0) and (cds < 6) then
	if ((cd - cds) < 1.5) or ((cds - cd < 1.5)) or ((6 - cds < 1.5) and (6 - cds > 0))  then
	return true
	else
	return false
	end
   end
   end
end

-- Ret Mode: Check if target is a demon or undead
function BangLibramSwap:CanExorcism()
	if (UnitCreatureType("target") == "Demon") or (UnitCreatureType("target") == "Undead") then
		return true

	else
		return false

	end
end


-- Check if exorcism is closer than judgement 
function BangLibramSwap:UseExorcism()

	local startx, durationx, enabledx = GetSpellCooldown(L["Exorcism"])  --, BOOKTYPE_SPELL
 local xcd = (startx + durationx) - GetTime()

	local startj, durationj, enabledj = GetSpellCooldown(L["Judgement"])  --, BOOKTYPE_SPELL
	local jcd = (startj + durationj) - GetTime()
	
	if (xcd) and (jcd) then
    	if ((xcd < 15.1) and (xcd > 0) and (jcd > 0) and (jcd < 10.1)) then
    		 if (cd - cds) > 1.6 then
     		 	return true;
     		 end
	     
		elseif (jcd < 0) or (jcd > 10.1) then
	 		 return false;

	   	end
	   	
	   	if  ( ((jcd < 10.1) and (jcd > 0)) and ((xcd < 0) or (xcd > 15.1))  ) then
	         return true;
	         
	    end
   	end
	
	if not (jcd) then
		return false
	end

end   


function BangLibramSwap:CanCastHeal()

  --BangLibramSwap:Debug("CanCastHeal Target:", HealTarget)
 inRange = IsSpellInRange("Flash of Light",HealTarget)

 usable, nomana = IsUsableSpell("Holy Light");
  
 if inRange==1  then
 	if (usable) then
 		return true
	end
	
 elseif not (inRange) or (nomana) or not (usable) then
  BangLibramSwap:Debug("CanCastHeal 0", ".")
 return false
 end
end



   
function BangLibramSwap:UNIT_SPELLCAST_FAILED(event, unit, spell, rank, targ)
if (unit ~= "player") then return end
    --    BangLibramSwap:Debug("Fail!", ".")

end
function BangLibramSwap:UNIT_SPELLCAST_INTERRUPTED(event, unit, spell, rank, targ)
    if (unit ~= "player") then return end
    BangLibramSwap:Debug("Interupt!", " .")

end
function BangLibramSwap:UNIT_SPELLCAST_STOP(event, unit, spell, rank, targ)
    if (unit ~= "player") then return end
   -- BangLibramSwap:Debug("STOP!", ".")
end
function BangLibramSwap:UNIT_SPELLCAST_SUCCEEDED(event, unit, spell, rank, targ)
    if (unit ~= "player") then return end

end

function BangLibramSwap:UNIT_SPELLCAST_START(event, unit, spell, rank, target)
if (unit ~= "player") then return end
self = BangLibramSwap
--[[
if not (self.db.profile.AutoLatencyDone) then
down, up, lag = GetNetStats();
self.db.profile.SpellClip = lag
DEFAULT_CHAT_FRAME:AddMessage("BLS: Auto Set Latency to: "..lag.." ms. Please check and adjust this.", 0.0, 0.65, 0.63)
self.db.profile.AutoLatencyDone = true

end


LagDelay = 0.06  -- mod 'think' time.
SpellClip = (self.db.profile.SpellClip/1000)

    local name, nameSubtext, text, texture, startTime, endTime, isTradeSkill = UnitCastingInfo("player")

    	local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo("Holy Light")
		castTime2 = castTime/1000
		CastFinish = castTime2 + GetTime()

    	NoSwapTime = GetTime() + castTime2 - LagDelay - SpellClip
    	
    	--MNoSwapTime = NoSwapTime - GetTime()
        --BangLibramSwap:Debug(SpellClip.." Latency. "..MNoSwapTime.."s swaps locked out. "..castTime2.." is the cast time.")

	  --]]


	   
	
	if (name =="Holy Wrath") then

		local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo("Holy Wrath")
		castTime2 = castTime/1000
		CastFinish = castTime2 + GetTime()
    	--BangLibramSwap:Debug(castTime2.." Holy Wrath CastTime")

    	NoSwapTime = GetTime() + castTime2  - SpellClip

	end


end


function BangLibramSwap:UNIT_SPELLCAST_SENT(event, unit, spell, rank, targ)
if (unit ~= "player") then return end
self = BangLibramSwap
HealTarget = targ

   BGLF  = L["Brutal Gladiator's Libram of Fortitude"] 	-- +39 resil
   VGLF  = L["Vengeful Gladiator's Libram of Fortitude"] 	-- +36 resil
   MGLF  = L["Merciless Gladiator's Libram of Fortitude"]   -- + 32 resil
   GLF  = L["Gladiator's Libram of Fortitude"] 		    -- 24 resil

   BGLV  = L["Brutal Gladiator's Libram of Vengeance"] 	-- +39 resil
   VGLV  = L["Vengeful Gladiator's Libram of Vengeance"] 	-- +36 resil
   MGLV  = L["Merciless Gladiator's Libram of Vengeance"]   -- + 32 resil
   GLV  = L["Gladiator's Libram of Vengeance"] 		    -- 24 resil
   LoSR = L["Libram of Souls Redeemed"]   -- BoL 60/120
   BBoN = L["Blessed Book of Nagrand"]    -- FoL +78
   LoAT = L["Libram of Absolute Truth"]   -- HL -37 mana
   LoM  = L["Libram of Mending"]          -- HL 22mp5
   LotL = L["Libram of the Lightbringer"] -- HL +89
   LoL  = L["Libram of Light"]            -- FoL +82
   BGL  = L["Brutal Gladiator's Libram of Justice"] 	-- +36 resil
   VGL  = L["Vengeful Gladiator's Libram of Justice"] 	-- +36 resil
   MGL  = L["Merciless Gladiator's Libram of Justice"]   -- + 32 resil
   GGL  = L["Gladiator's Libram of Justice"] 		    -- 24 resil

   LoRP = L["Libram of Righteous Power"]  -- +36 Crusader strike
   LoDJ = L["Libram of Divine Judgement"] -- JoC proc 200AP
   LoAV = L["Libram of Avengement"] -- JoC proc crit rating

   LoDP = L["Libram of Divine Purpose"]   -- +97 Righteousness
   LoCD = L["Libram of the Eternal Rest"] -- +47 concecrate
   LoES = L["Libram of Wracking"]  		 -- +120 Ex/HW

   LoHS = L["Libram of Repentance"]     	-- +5% Holy shield block
   LoJB = L["Tome of the Lightbringer"] 	 -- +189 block value
   LoZ  = L["Libram of Zeal"]  -- SotC Bonus
 --BangLibramSwap:Debug("SENTTarget:", HealTarget..". Event "..event..". Spell "..spell..". Rank "..rank)
   
	-- Auto Spec Selection, Holy is in the spells.

if (spell == L["Crusader Strike"]) then
	if (self.db.profile.AutoSpec) then
      self.db.profile.ret = true
      self.db.profile.holy = false
	  self.db.profile.prot = false
	 end

end

if (spell == L["Holy Shield"]) then
   if (self.db.profile.AutoSpec) then
       self.db.profile.prot = true
       self.db.profile.holy = false
       self.db.profile.ret = false
   end

end

if (spell =="Holy Light") then
        BangLibramSwap:Debug("HL cast")
	
        
        --LoM double cast bug fix
		if (LoMCast) then
    	LastLoMCast = GetTime() - LoMCast
    	end


  		if (LastLoMCast) then
  			if (LastLoMCast < 30) then
				if ((LastLoMCast < 5) and (LastLoMCast > 0))   then
				LoMCastRecently = true
				else
				LoMCastRecently = false
	            end
			else
			LoMCastRecently = false
	    	end                                                       
		end




	 if not (self.db.profile.holy) and (self.db.profile.AutoSpec) then
  	 self.db.profile.holy = true
		self.db.profile.prot = false
		self.db.profile.ret = false

	 end


        if (   (LoMCastRecently) or (BangLibramSwap:HasMendingBuff()) or (self.db.profile.NoLoM)    ) and (not (self.db.profile.LoM))  then

			if (BangLibramSwap:HasBoL(HealTarget)) then
               if (self.db.profile.LoAT) and (not (self.db.profile.LoM)) and (not (self.db.profile.LoSR)) and (not (SpamProof)) then
			  	self.db.profile.libram = LoAT
			    elseif (self.db.profile.LoSR) and (not (self.db.profile.LoM)) and (not (SpamProof)) then
               	self.db.profile.libram = LoSR
				elseif (self.db.profile.LotL) and (not (self.db.profile.LoM)) and (not (SpamProof)) then
               	self.db.profile.libram = LotL
               	else
               	BangLibramSwap:Debug("Error: HasBoL No libram fire", LotL)
				end

            else
			   if (self.db.profile.LoAT) and (not (self.db.profile.LoM))  then
			  	 self.db.profile.libram = LoAT
                 elseif (self.db.profile.LotL) and (not (self.db.profile.LoM)) then
               	self.db.profile.libram = LotL

				else
				BangLibramSwap:Debug("Error: Not-HasBoL No libram fire", LotL)
				end

           end

         else
            if (not (LoMCastRecently)) then
                self.db.profile.libram = LoM
                
            end


 		 end
        
       BangLibramSwap:Debug("Libram Q'd: "..self.db.profile.libram) 
        
	end

if (spell =="Flash of Light") then

--[[		local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo("Flash of Light")
		castTime2 = castTime/1000
		CastFinish = castTime2 + GetTime()
    	BangLibramSwap:Debug(castTime2.." Flash of Light CastTime")

    	NoSwapTime = GetTime() + castTime2  - SpellClip
    	
    	 if not (self.db.profile.holy) and (self.db.profile.AutoSpec) then
	    self.db.profile.holy = true
		self.db.profile.prot = false
		self.db.profile.ret = false

	 end ]]
      -- Start Auto PVP Selection 
   if (self.db.profile.AutoMode)  then
   	
   	
  if (not (self.db.profile.Mp5Mode)) and IsInInstance() and (not    (  (GetNumBattlefieldStats() > 1) or (IsActiveBattlefieldArena())  )   ) then
    	self.db.profile.Mp5Mode = true,
    	self:Debug("BLS: PVE Mode Forced - You're in an instance!", 1.0, 0.85, 0.43)
  elseif not(IsInInstance() and (not  (  (GetNumBattlefieldStats() > 1) or (IsActiveBattlefieldArena()) )  )) then
	  if (BangLibramSwap:UnitIsPVP("target")) then
	 	 if (self.db.profile.Mp5Mode) then
	  	  	self:Debug("Target is PVP Enabled - Overriding PVE Mode", VGL)
	  	  	self.db.profile.Mp5Mode = false
		 end
		 
	  else
	  
	      if (not (self.db.profile.Mp5Mode)) then
	  	  	 self:Debug("Target is *not* PVP Enabled - Overriding PVP Mode", BBoN)
	  	  	 self.db.profile.Mp5Mode = true
	  	  end
	  	  
	  end
   end	  

  end   -- End Automatic selection
   
	  if (self.db.profile.Mp5Mode) then
            if (self.db.profile.LoL) and (not (self.db.profile.LoSRFoL)) then
			   self.db.profile.libram = LoL
            elseif (self:HasBoL(targ)) and (self.db.profile.LoSRFoL) then
			   self.db.profile.libram = LoSR
            else
			   self.db.profile.libram = BBoN
			end
			
	   elseif not (self.db.profile.Mp5Mode) then		
	         if (self.db.profile.Glad1) then
			  	self.db.profile.libram = GGL
			  end
			  
			  if (self.db.profile.Glad2) then
			  	self.db.profile.libram = MGL
			  end
			  
			  if (self.db.profile.Glad3) then
			  	 self.db.profile.libram = VGL
			  end
			  
			    if (self.db.profile.Glad4) then
			  	 self.db.profile.libram = BGL
			  end
	 end
	      
	    --[[	if (NoSwapTime) then
		LastSwap = NoSwapTime - GetTime()

		if (LastSwap <= 0) and (BangLibramSwap:CanCastHeal()) and (self.db.profile.Enabled) and (self.db.profile.holy) then
    		BangLibramSwap:GetLibram()
		--	EquipItemByName(self.db.profile.libram)
		elseif (LastSwap > 0)  and (LastSwap < 0.25)  then
		    NoSwapTime = NoSwapTime + 0.3
		end
	end   ]]

      BangLibramSwap:Debug("Libram Q'd: "..self.db.profile.libram) 
	end
  --CS logic. Ret
    
   	if (spell == L["Crusader Strike"]) and (self.db.profile.ret) and (self.db.profile.Enabled) then

    --Ret3Cycle Check
	if (self.db.profile.Ret3Cycle) and (self.db.profile.HolyES) then
	   if BangLibramSwap:CanExorcism() and BangLibramSwap:UseExorcism() then
			EquipItemByName(LoES)
			--ScrollingMessageFrame:AddMessage("Exorcism!", 1.0, 0.85, 0.43)
			return
		end
   end



       	 -- Ret2Cycle Timer
		if (LoDJProc) then
    	LastLoDJProc = GetTime() - LoDJProc
    	end
    	
        
  		if (LastLoDJProc) then
  			if ((LastLoDJProc) < 3000) then
				if (    ( (LastLoDJProc) < 1) and ( (LastLoDJProc) > -10)    ) then   
					--self:Debug("BLS: LastLoDJProc -10 to 1s? "..LastLoDJProc, 1.0, 0.85, 0.43)
				LoDJProcRecently = true
				else
				LoDJProcRecently = false
	            end
			else
			LoDJProcRecently = false
	    	end
		end


   	    if not     (BangLibramSwap:JudgementCD2() )    then
              -- Start Auto PVP Selection 
			if (self.db.profile.AutoMode)  then
   	
   	
  			if (not (self.db.profile.Mp5Mode)) and IsInInstance() and (not  (  (GetNumBattlefieldStats() > 1) or (IsActiveBattlefieldArena()) )  ) then
    				self.db.profile.Mp5Mode = true,
    				self:Debug("BLS: PVE Mode Forced - You're in an instance!", 1.0, 0.85, 0.43)
 			 elseif not(IsInInstance() and (not   ( (GetNumBattlefieldStats() > 1) or (IsActiveBattlefieldArena()) )  )) then
				  if (BangLibramSwap:UnitIsPVP("target")) then
	 				 if (self.db.profile.Mp5Mode) then
	  				  	self:Debug("Target is PVP Enabled - Overriding PVE Mode", VGL)
	  	 			 	self.db.profile.Mp5Mode = false
		 			end
		 
	  			else
	  
	    			  if (not (self.db.profile.Mp5Mode)) then
	  	 			 	 self:Debug("Target is *not* PVP Enabled - Overriding PVP Mode", BBoN)
	  	 			 	 self.db.profile.Mp5Mode = true
	  				  end
	  	  
	 			 end
 		  end	  

  end   -- End Automatic selection                
					if (self.db.profile.Mp5Mode) or (not ((self.db.profile.RetJudge1) or (self.db.profile.RetJudge2) or (self.db.profile.RetJudge3) or(self.db.profile.RetJudge4))) then

						if (self.db.profile.DJ) then
							if (self.db.profile.Ret2Cycle) and (LoDJProcRecently) and (self.db.profile.AV) then
			  	    	    EquipItemByName(LoAV)
							return
							end
			  	    	EquipItemByName(LoDJ)
						end
						
						
					    if  (self.db.profile.AV) and (not(self.db.profile.Ret2Cycle)) then
			  	    	EquipItemByName(LoAV)
			  	    	end
			  	    	
			  	    elseif (not(self.db.profile.Mp5Mode)) then	
			  	    	
			  	    	if  (self.db.profile.RetJudge1) then
			  	    	EquipItemByName(GLF)
			  	    	end
			  	    	if  (self.db.profile.RetJudge2) then
			  	    	EquipItemByName(MGLF)
			  	    	end
			  	    	if  (self.db.profile.RetJudge3) then
			  	    	EquipItemByName(VGLF)
			  	    	end
			  	    		if  (self.db.profile.RetJudge4) then
			  	    	EquipItemByName(BGLF)
			  	    	end
			  	    end
       	else
        	       self:Debug("Potential GCD, CS->Judge swap aborted", 1.0, 0.85, 0.43)
           	-- BangLibramSwap:SwapAfterGCD()
        end
   	end
   	
      -- Libram of Zeal, SotC logic
    if (spell == L["Seal of the Crusader"]) and (self.db.profile.Enabled) and (self.db.profile.LoZ) then
			   EquipItemByName(LoZ)
   end	
   	
   -- Judgement logic. Holy
    if (spell == L["Judgement"]) and (self.db.profile.Enabled) and (self.db.profile.holy) and (self.db.profile.HolyDP) then
			   EquipItemByName(LoDP)
			      BangLibramSwap:Debug(LoDP)
   end
   
   
      --Instant Swaps
    if ( (spell == "Seal of Righteousness") or (spell == "Blessing of Freedom") or (spell == "Blessing of Might") or (spell == "Blessing of Kings") or (spell == "Blessing of Light") or (spell == "Seal of Wisdom") or (spell == "Seal of Justice") or (spell == "Seal of light") or  (spell == "Blessing of Wisdom") or (spell == "Holy Shock") or (spell == "Hammer of Justice") )  and (self.db.profile.Enabled) and (self.db.profile.holy) then
			    EquipItemByName(self.db.profile.libram)
			   BangLibramSwap:Debug("Instant Fire")
			    BangLibramSwap:Debug(self.db.profile.libram)
   end
   
   

   -- Concecrate Logic
    if (spell == L["Consecration"]) then
	if  (self.db.profile.HolyCD) and ( (self.db.profile.holy) or ((self.db.profile.prot) and not(self.db.profile.HS))   )  then
			   EquipItemByName(LoCD)
   end         BangLibramSwap:Debug("Conc: ",LoCD)
   end
   
   -- Holy Wrath/Exorcism Logic
   if (spell == L["Exorcism"]) and (self.db.profile.holy) and (self.db.profile.HolyES) and (self.db.profile.Enabled) then
			   EquipItemByName(LoES)
   end
   
   -- Return Judgement libram while in ret mode
   if (spell == L["Exorcism"]) and (self.db.profile.ret) and (self.db.profile.Ret3Cycle) then
   	  		
    					if (self.db.profile.DJ) then
							if (self.db.profile.Ret2Cycle) and (LoDJProcRecently) and (self.db.profile.AV) then
			  	    	    EquipItemByName(LoAV)
							return
							end
			  	    	EquipItemByName(LoDJ)
						end
						
						
					    if  (self.db.profile.AV) and (not(self.db.profile.Ret2Cycle)) then
			  	    	EquipItemByName(LoAV)
			  	    	end
			  	    	

   end
   
  
end

-- BangLibramSwap:HasBoL and HasMendingBuff code from Ladenedge's Holy Librams.

function BangLibramSwap:HasBoL()

   return self:BuffByTexture(HealTarget, "Spell_Holy_PrayerOfHealing02") or self:BuffByTexture(target, "Spell_Holy_GreaterBlessingofLight")

end

function BangLibramSwap:UnitIsPVP()
   return UnitIsPVP(HealTarget)

end




function BangLibramSwap:HasHolyShield(player)

	return self:BuffByTexture(player, "Spell_Holy_BlessingOfProtection")
end


function BangLibramSwap:HasMendingBuff()
	
   local mending_buff_name = L["Grace of the Naaru"]

   for id = 1,100 do
      local name, _, _, _, _, time_left = UnitBuff("player", id)
      if (not name or not time_left) then
         return false 
      elseif (name == mending_buff_name) then
         --self:Debug("Mending buff is active, timeleft: ", time_left)
         return time_left >= self.db.profile.RefreshWindow
      end
   end

end

function BangLibramSwap:BuffByTexture(unit, texture_to_find)

   for id = 1,100 do
      local _, _, texture = UnitBuff("target", id)
      if (not texture) then
         return false
      elseif (texture == "Interface\\Icons\\" .. texture_to_find) then
         return true
      end
   end

end

function BangLibramSwap:Debug(e, s)
z = "!"
if (self.db.profile.Debug) then
      self:Print(e, s, z)
end

end

function BangLibramSwap:Print(e, s, z)

   if (e) and (s) then
   DEFAULT_CHAT_FRAME:AddMessage(z.." "..e.." "..s.." ", 1.0, 0.85, 0.43)
   elseif (e) then
    DEFAULT_CHAT_FRAME:AddMessage(z.." "..e.." ", 1.0, 0.85, 0.43)
   elseif (s) then
    DEFAULT_CHAT_FRAME:AddMessage(z.." "..s.." ", 1.0, 0.85, 0.43)
    end
end
